#ifndef LIB_COLLISION_H
#define LIB_COLLISION_H

#include "math/vec.h"

//collision structure:
typedef struct {
	float	frac;			//fraction of distance travelled
	vec3f	x;				//position of intersection
	plane3f	p;				//plane of surface for collided point
	vec3f	vtx[3];			//three points of the triangle
	float	bcc[3];			//three barycentric coordinates to the collision
	float	restitution;	//restitution of surface
	float	friction;		//friction of surface
} col_t;

float testSphereTriCollision(const vec3f &p1, const vec3f &p2, float radius, const vec3f **points, plane3f *resultPlane, float *bcc);
float testSphereSphereCollision(const vec3f &p1, const vec3f &p2, float radius, const vec3f &pTest, float radTest, plane3f *resultPlane);

#endif
