#include <stdio.h>
#include "defs/defs.h"
#include "system/gl.h"
#include "lib/light.h"

void Light::setup(int index, int flags) {
	index += GL_LIGHT0;

	if (flags & LIGHT_POS)	glLightfv(index, GL_POSITION, pos);
	if (flags & LIGHT_AMB)	glLightfv(index, GL_AMBIENT, amb);
	if (flags & LIGHT_DIFF)	glLightfv(index, GL_DIFFUSE, diff);
	if (flags & LIGHT_SPEC)	glLightfv(index, GL_SPECULAR, spec);
	if (flags & LIGHT_ATTN) {
		glLightf(index, GL_CONSTANT_ATTENUATION, attn.x);
		glLightf(index, GL_LINEAR_ATTENUATION, attn.y);
		glLightf(index, GL_QUADRATIC_ATTENUATION, attn.z);
	}
}

void Light::enable(int index) {
	glEnable(GL_LIGHT0 + index);
}

void Light::disable(int index) {
	//todo - upper bound / index validity test?
	glDisable(GL_LIGHT0 + index);
}