#include "lib/objfilecache.h"

ObjFile *ObjFileCache::load(const char *fn, bool genEdges) {

	for (int i = 0; i < (int)objFiles.size(); i++) {
		if (!strcmp(objFiles[i]->getTitle(), fn)				//if the names match
			&& (genEdges == !!objFiles[i]->getEdges().size()) )	//and the edge data matches
		{
			return objFiles[i];
		}
	}

	ObjFile *file = new ObjFile();
	if (!file) return NULL;
	if (!file->load(fn,genEdges)) {
		delete file;
		return NULL;
	}

	objFiles.push_back(file);

	return file;
}


void ObjFileCache::reset() {
	objFiles.clear();
}

void ObjFileCache::shutdown() {
	
	//objFiles
	for (int i = 0; i < (int)objFiles.size(); i++) {
		if (objFiles[i]) delete objFiles[i];
	}
	
	//clear all
	reset();
}